<?php
class AmazonStructHandler
{
	var $db_;
	var $cachetime_;
	
	function AmazonStructHandler()
	{
		global $xoopsDB;
		$this->db_=$xoopsDB;
	}
	
	function &getInstance()
	{
		static $handler;
		if(!is_object($handler))
			$handler=new AmazonStructHandler();

		return $handler;
	}

	function setCacheTime($time)
	{
		$this->cachetime_=$time;
	}

	function isCache($asin)
	{
		$sql="SELECT limit_time FROM ".$this->db_->prefix('amazonmap_cache').
			" WHERE asin='".trim($asin)."'";
		$res=$this->db_->query($sql);

		if($row=$this->db_->fetchArray($res)) {
			if($row['limit_time']<time()) {
				$this->db_->queryF("DELETE FROM ".$this->db_->prefix('amazonmap_cache').
					" WHERE asin='".trim($asin)."'");
				return false;
			}
			return true;
		}
		
		return false;
	}

	function build($asin)
	{
		$ret = array();
		$sql="SELECT * FROM ".$this->db_->prefix('amazonmap_cache').
			" WHERE asin='".trim($asin)."'";
		$res=$this->db_->query($sql);
		if($row=$this->db_->fetchArray($res)) {
			$ret=unserialize($row['value']);
			return $ret;
		}
		else {
			return false;
		}
	}
	
	function cache($asin,$arr)
	{
		$this->db_->queryF("DELETE FROM ".$this->db_->prefix('amazonmap_cache').
			" WHERE asin='".trim($asin)."'");
			
		$limit_time=time()+($this->cachetime_*60);
		
		$sql=@sprintf("INSERT INTO ".$this->db_->prefix('amazonmap_cache').
			" (asin,limit_time,value) VALUES ( %s,%u,%s )",
				$this->db_->quoteString($asin),
				$limit_time, 
				$this->db_->quoteString(serialize($arr))
			);

		$this->db_->queryF($sql);	
	}
}

?>